#ifndef EVENEMENT_H
#define EVENEMENT_H

#include <windows.h> // beurk, on peut faire mieux

class Evenement
{
   HANDLE evenement_;
public:
   enum { INFINI = INFINITE }; // hum
   class AutoReset {};
   class ManualReset {};
   Evenement(AutoReset)
      : evenement_(CreateEvent(0, FALSE, FALSE, 0))
   {
   }
   Evenement(ManualReset)
      : evenement_(CreateEvent(0, TRUE, FALSE, 0))
   {
   }
   ~Evenement() throw ()
      { CloseHandle(evenement_); }
   bool attendre() const volatile throw()
      { return attendre(INFINI); }
   bool attendre (const long delai) const volatile throw()
      { return WaitForSingleObject(evenement_, delai) == WAIT_OBJECT_0; }
   void provoquer() const volatile throw()
      { SetEvent(evenement_); }
   void reinitialiser() const volatile throw()
      { ResetEvent(evenement_); }
};

#endif
