#include "FamillesAdresse.h"
#include "ComplementsPaires.h"
#include <vector>
using std::vector;
#include <algorithm>
using std::find_if;
#include <winsock2.h>

namespace SocketsFlux
{
   GestionnaireFamilles::GestionnaireFamilles()
   {
      corresp_.push_back(Correspondance(Unspecified,AF_UNSPEC));
      corresp_.push_back(Correspondance(Unix,AF_UNIX));
      corresp_.push_back(Correspondance(Inet,AF_INET));
      corresp_.push_back(Correspondance(Inet6,AF_INET6));
      // etc.
   }

   GestionnaireFamilles::famille_type
      GestionnaireFamilles::trouver(const FamilleAdresse fam) const
   {
      vector<Correspondance>::const_iterator itt =
         find_if(corresp_.begin(), corresp_.end(),
                  match_first<FamilleAdresse,famille_type>(fam));
      if (itt == corresp_.end()) throw Introuvable();
      return itt->second;
   }

   GestionnaireFamilles::~GestionnaireFamilles() throw()
      { }
   GestionnaireFamilles GestionnaireFamilles::singleton;
}
