#include "FamillesProtocole.h"
#include "ComplementsPaires.h"
#include <vector>
using std::vector;
#include <algorithm>
using std::find_if;
#include <winsock2.h>

namespace SocketsFlux
{
   GestionnaireProtocoles::GestionnaireProtocoles()
   {
      corresp_.push_back(Correspondance(IpV4,IPPROTO_IPV4));
      corresp_.push_back(Correspondance(Tcp,IPPROTO_TCP));
      corresp_.push_back(Correspondance(Udp,IPPROTO_UDP));
      corresp_.push_back(Correspondance(IpV6,IPPROTO_IPV6));
      // etc.
   }

   GestionnaireProtocoles::protocole_type
      GestionnaireProtocoles::trouver(const FamilleProtocole fam) const // throw(Introuvable)
   {
      vector<Correspondance>::const_iterator itt =
         find_if(corresp_.begin(), corresp_.end(),
                  match_first<FamilleProtocole,protocole_type>(fam));
      if (itt == corresp_.end()) throw Introuvable();
      return itt->second;
   }

   GestionnaireProtocoles::~GestionnaireProtocoles() throw()
      { }
   GestionnaireProtocoles GestionnaireProtocoles::singleton;
}

