#ifndef MUTEX_H
#define MUTEX_H

#include "Incopiable.h"
#include <windows.h> // non portable; on peut faire mieux

class Mutex
   : Incopiable
{
   HANDLE mutex_;
public:
   Mutex()
      : mutex_(CreateMutex(0, FALSE, 0))
   {
   }
   ~Mutex() throw()
      { CloseHandle(mutex_); }
   void obtenir() const volatile throw()
      { WaitForSingleObject(mutex_, INFINITE); }
   void relacher() const volatile throw()
      { ReleaseMutex(mutex_); }
};

class Autoverrou
   : Incopiable
{
   const volatile Mutex &mutex_;
public:
   Autoverrou(const volatile Mutex &m)
      : mutex_(m)
   {
      mutex_.obtenir();
   }
   ~Autoverrou() throw()
      { mutex_.relacher(); }
};

#endif
