#ifndef SOCKET_BASE_H
#define SOCKET_BASE_H

#include "FamillesAdresse.h"
#include "FamillesProtocole.h"
#include "Port.h"
#include "Adresse.h"
#include "ISocket.h"

namespace SocketsFlux
{
   //
   // Un SocketFlux::SocketBase est une enveloppe autour de l'abstraction
   // qu'est un SocketFlux::SocketPrimitif
   //
   class SocketBase
   {
      ISocket *socket_;
   public:
      SocketBase(const FamilleAdresse fam = Inet, const FamilleProtocole proto = Tcp)
         : socket_(ISocket::Creer(fam , proto))
      {
         GestionnaireSockets&(*pPatch)() = GestionnaireSockets::get;
      }
      ISocket &socket() throw()
         { return *socket_; }
      template <class T, class Itt>
         int envoyer(Itt debut, Itt fin)
            { return socket().envoyer<T>(debut, fin); }
      template <class T, class Itt>
         int recevoir(Itt debut, Itt fin)
            { return socket().recevoir<T> (debut, fin); }
      ~SocketBase() throw()
         { delete socket_; }
   };
}

#endif
